 set kernel_options pfcolors no_blank_lines background
 rem future ideas: 
 rem - title screen
 rem - more blocks

 dim _GameState = a
 def _EvDir=_GameState{1}
 def _Debounce=_GameState{2}
 dim _Species = b
 dim _InputCounter = c
 dim _AnimFrame = d
 dim _GarbageLevel = e
 dim _GarbageProb = f
 dim _GarbageFrame = g
 dim _Level = l
 dim _SoundEffect = s
 dim _SoundCounter = t
 dim _Speed = w
 rem x, y - position

 rem title
 dim _TitleColor = z

 dim sc1 = score
 dim sc2 = score + 1
 dim sc3 = score + 2

 const Y_SKY = 30
 const Y_GROUND = 61
 const Y_TOP = 3
 const Y_BOTTOM = 87
 const X_LEFT = 15
 const X_RIGHT = 110

 const SND_NONE = 0
 const SND_EVOLVE_UP = 1
 const SND_EVOLVE_DOWN = 2
 const SND_DIE = 3
 const SND_LEVELUP = 4
 
 const MAX_SPEED = 9
 const MIN_SPEED = 2
 const MIN_GARBAGE = 2
 const MAX_GARBAGE = 3
 const MIN_GARBAGEPROB = 3
 const MAX_GARBAGEPROB = 6
 rem initialize colours
 pfcolors:
 $8E
 $8E
 $8E
 $8E
 $C4
 $F4
 $F2
 $F0
 $AA
 $A8
 $A6
 $A4
end

 scorecolor = $0e
 COLUP0 = $00
 COLUP1 = $00
 _SoundEffect = 0

title
 player1y = 128
 COLUPF = _TitleColor
 _TitleColor = _TitleColor + 1
 temp1 = rand
 playfield:
 XXX.X.X..X..X...X.X.XXX.....X..X
 X...X.X.X.X.X...X.X.X.......X..X
 XX..X.X.X.X.X...X.X.XX......X..X
 X...X.X.X.X.X...X.X.X.......X..X
 XXX..X...X..XXX..X..XXX......XX.
 ................................
 ....XXX.X..X..XX.X..X.XXX.XX....
 ....X...X..X.X...X.X..X...X.X...
 ....XX..X..X.X...XX...XX..XX....
 ....X...X..X.X...X.X..X...X.X...
 ....X....XX...XX.X..X.XXX.X.X...
end

 if joy0fire && !_Debounce then goto start
 if !joy0fire then _Debounce = 0
 drawscreen 
 gosub doSound
 goto title

start
 pfclear
 COLUPF = $00
 score = 0
 _GameState = 0
 _GarbageFrame = 0
 _Level = 0
 _Speed = MAX_SPEED
 _GarbageProb = MIN_GARBAGEPROB
 _GarbageLevel = MAX_GARBAGE
 if joy0fire then _Debounce = 1
 x=30 : y = 75
 _Species = 0

gameloop
 temp2 = _Level
 _Level = sc2
 if _Level < temp2 then _Level = temp2
 if temp2 <> _Level then _SoundEffect = SND_LEVELUP : _SoundCounter = 0 : _GarbageFrame = 0
 if _Speed > MIN_SPEED then _Speed = MAX_SPEED - _Level
 temp1 = _Level / 2
 if _GarbageProb < MAX_GARBAGEPROB then _GarbageProb = MIN_GARBAGEPROB + temp1

 _AnimFrame = _AnimFrame + 1
 if _GarbageFrame = 0 then score = score + 1
 _GarbageFrame = _GarbageFrame + 1
 if _GarbageFrame = _Speed then gosub destroyGarbage
 temp1 = _Speed + 1
 if _GarbageFrame = temp1 then gosub createGarbage
 temp1 = _Speed + 2
 if _GarbageFrame = temp1 then pfscroll left : _GarbageFrame = 0

 player1x=x
 player1y=y
 if _Species = 0 then goto doFish
 if _Species = 1 then goto doLizard
doBird
 if _AnimFrame > 14 then _AnimFrame = 0
 if _AnimFrame > 7 then goto drawBirdFrame2
 player1:
 %00000000
 %10011001
 %01100110
end
 goto handleInputBird
drawBirdFrame2
 player1:
 %01000010
 %00100100
 %00011000
end
handleInputBird
 if y < Y_SKY then goto handleInputFast
 if y < Y_GROUND then goto handleInputSlow
 goto die

doFish
 if _AnimFrame > 20 then _AnimFrame = 0
 if _AnimFrame > 10 then goto drawFishFrame2
 player1:
 %10011110
 %01111111
 %01111101
 %10011110
end
 goto handleInputFish
drawFishFrame2
 player1:
 %01011110
 %01111111
 %01111101
 %01011110
end
handleInputFish
 if y < Y_GROUND then goto die 
 goto handleInputFast

doLizard
 if _AnimFrame > 10 then _AnimFrame = 0
 if _AnimFrame > 5 then goto drawLizardFrame2
 player1:
 %10000001
 %01111110
 %11111010
 %10001100
 %01000000
end
 goto handleInputLizard
drawLizardFrame2
 player1:
 %00100100
 %01111110
 %01111010
 %01001100
 %00100000
end

handleInputLizard
 if y < Y_SKY then goto handleInputFall
 if y < Y_GROUND then goto handleInputFast
handleInputSlow
 _InputCounter = _InputCounter + 1
 if _InputCounter < 3 then goto handleInputCommon
 _InputCounter = 0
handleInputFast
 if joy0up then y=y-1
 if joy0down then y=y+1
handleInputLeftRight
 if joy0right then x=x+1
 if joy0left then x=x-1
handleInputCommon
 if joy0right then REFP1 = 0
 if joy0left then REFP1 = 8
 if y < Y_TOP then y = Y_TOP
 if y > Y_BOTTOM then y = Y_BOTTOM
 if x < X_LEFT then x = X_LEFT
 if x > X_RIGHT then x = X_RIGHT
 if joy0fire then gosub evolve else _Debounce = 0
 
doDraw
 player1x=x :  player1y=y
 drawscreen
 gosub doSound
 if collision(player1, playfield) then goto die
 goto gameloop

handleInputFall
 y = y + 1
 goto handleInputLeftRight

evolve
 if _Debounce then return
 _Debounce = 1
 _SoundCounter = 0
 if _Species = 0 then _Species = 1: _EvDir = 1: _SoundEffect = SND_EVOLVE_UP : return
 if _Species = 1 && _EvDir then _Species = 2: _SoundEffect = SND_EVOLVE_UP : return
 if _Species = 1 then _Species = 0 : _SoundEffect = SND_EVOLVE_DOWN : return
 _EvDir = 0 : _Species = 1 : _SoundEffect = SND_EVOLVE_DOWN : return

createGarbage
 temp2 = rand & 7
 if temp2 > _GarbageProb then return
 def _GarbageCount=temp4
 def _GarbageY=temp3
 _GarbageCount = _GarbageLevel
garbageLoop
 _GarbageCount = _GarbageCount - 1
 if _GarbageCount = 0 then return
 _GarbageY = (rand & 15)
 if _GarbageY <= 11 then pfpixel 31 _GarbageY on
 goto garbageLoop

destroyGarbage
 _GarbageY = 11
destroyGarbageLoop
 pfpixel 0 _GarbageY off
 if _GarbageY = 0 then return
 _GarbageY = _GarbageY - 1
 goto destroyGarbageLoop
 
die
 _SoundEffect = SND_DIE
 _SoundCounter = 0
 goto title

doSound
 if _SoundEffect = 0 then AUDV0 = 0 : return
 if _SoundEffect = SND_EVOLVE_UP then AUDV0 = 8 : AUDC0 = 3 : AUDF0 = 31 - _SoundCounter
 if _SoundEffect = SND_EVOLVE_DOWN then AUDV0 = 8 : AUDC0 = 3 : AUDF0 = _SoundCounter
 if _SoundEffect = SND_DIE then AUDV0 = 8 : AUDC0 = 6 : AUDF0 = _SoundCounter
 if _SoundEffect = SND_LEVELUP then AUDV0 = 8 : AUDC0 = 14 : AUDF0 = 31 - _SoundCounter
 _SoundCounter = _SoundCounter + 1
 if _SoundCounter = 32 then _SoundCounter = 0 : _SoundEffect = 0
 return
