 processor 6502
 include "vcs.h"
 include "macro.h"
 include "2600basic.h"
 include "2600basic_variable_redefs.h"
 ifconst bankswitch
  if bankswitch == 8
     ORG $1000
     RORG $D000
  endif
  if bankswitch == 16
     ORG $1000
     RORG $9000
  endif
  if bankswitch == 32
     ORG $1000
     RORG $1000
  endif
 else
   ORG $F000
 endif
; This is a 2-line kernel!
kernel
 sta WSYNC
 lda #255
 sta TIM64T

 lda #1
 sta VDELBL
 sta VDELP0
 ldx ballheight
 inx
 inx
 stx temp4
 lda player1y
 sta temp3

 ifconst shakescreen
   jsr doshakescreen
 else
   ldx missile0height
   inx
 endif

 inx
 stx stack1

 lda bally
 sta stack2

 lda player0y
 ldx #0
 sta WSYNC
 stx GRP0
 stx GRP1
 stx PF1L
 stx PF2
 stx CXCLR
 ifconst readpaddle
   stx paddle
 else
   sleep 3
 endif

 sta temp2,x

 ;store these so they can be retrieved later
 ifnconst pfres
   ldx #128-44+(4-pfwidth)*12
 else
   ldx #132-pfres*pfwidth
 endif

 dec player0y

 lda missile0y
 sta temp5
 lda missile1y
 sta temp6

 lda playfieldpos
 sta temp1
 
 ifconst pfrowheight
 lda #pfrowheight+2
 else
 ifnconst pfres
   lda #10
 else
   lda #(96/pfres)+2 ; try to come close to the real size
 endif
 endif
 clc
 sbc playfieldpos
 sta playfieldpos
 jmp .startkernel

.skipDrawP0
 lda #0
 tay
 jmp .continueP0

.skipDrawP1
 lda #0
 tay
 jmp .continueP1

.kerloop ; enter at cycle 59??

continuekernel
 sleep 2
continuekernel2
 lda ballheight
 
 ifconst pfres
 ldy playfield+pfres*pfwidth-132,x
 sty PF1L ;3
 ldy playfield+pfres*pfwidth-131-pfadjust,x
 sty PF2L ;3
 ldy playfield+pfres*pfwidth-129,x
 sty PF1R ; 3 too early?
 ldy playfield+pfres*pfwidth-130-pfadjust,x
 sty PF2R ;3
 else
 ldy playfield-48+pfwidth*12+44-128,x
 sty PF1L ;3
 ldy playfield-48+pfwidth*12+45-128-pfadjust,x ;4
 sty PF2L ;3
 ldy playfield-48+pfwidth*12+47-128,x ;4
 sty PF1R ; 3 too early?
 ldy playfield-48+pfwidth*12+46-128-pfadjust,x;4
 sty PF2R ;3
 endif

 ; should be playfield+$38 for width=2

 dcp bally
 rol
 rol
; rol
; rol
goback
 sta ENABL 
.startkernel
 lda player1height ;3
 dcp player1y ;5
 bcc .skipDrawP1 ;2
 ldy player1y ;3
 lda (player1pointer),y ;5; player0pointer must be selected carefully by the compiler
			; so it doesn't cross a page boundary!

.continueP1
 sta GRP1 ;3

 ifnconst player1colors
   lda missile1height ;3
   dcp missile1y ;5
   rol;2
   rol;2
   sta ENAM1 ;3
 else
   lda (player1color),y
   sta COLUP1
 ifnconst playercolors
   sleep 7
 else
   lda.w player0colorstore
   sta COLUP0
 endif
 endif

 ifconst pfres
 lda playfield+pfres*pfwidth-132,x 
 sta PF1L ;3
 lda playfield+pfres*pfwidth-131-pfadjust,x 
 sta PF2L ;3
 lda playfield+pfres*pfwidth-129,x 
 sta PF1R ; 3 too early?
 lda playfield+pfres*pfwidth-130-pfadjust,x 
 sta PF2R ;3
 else
 lda playfield-48+pfwidth*12+44-128,x ;4
 sta PF1L ;3
 lda playfield-48+pfwidth*12+45-128-pfadjust,x ;4
 sta PF2L ;3
 lda playfield-48+pfwidth*12+47-128,x ;4
 sta PF1R ; 3 too early?
 lda playfield-48+pfwidth*12+46-128-pfadjust,x;4
 sta PF2R ;3
 endif 
; sleep 3

 lda player0height
 dcp player0y
 bcc .skipDrawP0
 ldy player0y
 lda (player0pointer),y
.continueP0
 sta GRP0

 ifnconst no_blank_lines
 ifnconst playercolors
   lda missile0height ;3
   dcp missile0y ;5
   sbc stack1
   sta ENAM0 ;3
 else
   lda (player0color),y
   sta player0colorstore
   sleep 6
 endif
   dec temp1
   bne continuekernel
 else
   dec temp1
   beq altkernel2
 ifconst readpaddle
   ldy currentpaddle
   lda INPT0,y
   bpl noreadpaddle
   inc paddle
   jmp continuekernel2
noreadpaddle
   sleep 2
   jmp continuekernel
 else
 ifnconst playercolors 
 ifconst PFcolors
   txa
   tay
   lda (pfcolortable),y
 ifnconst backgroundchange
   sta COLUPF
 else
   sta COLUBK
 endif
   jmp continuekernel
 else
 ifconst kernelmacrodef
   kernelmacro
 else
   sleep 12
 endif
 endif
 else
   lda (player0color),y
   sta player0colorstore
   sleep 4
 endif
   jmp continuekernel
 endif
altkernel2
   txa
   sbx #256-pfwidth
   bmi lastkernelline
 ifconst pfrowheight
 lda #pfrowheight
 else
 ifnconst pfres
   lda #8
 else
   lda #(96/pfres) ; try to come close to the real size
 endif
 endif
   sta temp1
   jmp continuekernel
 endif

altkernel

 ifconst PFmaskvalue
   lda #PFmaskvalue
 else
   lda #0
 endif
 sta PF1L
 sta PF2


 ;sleep 3

 ;28 cycles to fix things
 ;minus 11=17

; lax temp4
; clc
 txa
 sbx #256-pfwidth

 bmi lastkernelline

 ifconst PFcolorandheight
   ifconst pfres
     ldy playfieldcolorandheight-131+pfres*pfwidth,x
   else
     ldy playfieldcolorandheight-87,x
   endif
 ifnconst backgroundchange
   sty COLUPF
 else
   sty COLUBK
 endif
   ifconst pfres
     lda playfieldcolorandheight-132+pfres*pfwidth,x
   else
     lda playfieldcolorandheight-88,x
   endif
   sta.w temp1
 endif
 ifconst PFheights
   lsr
   lsr
   tay
   lda (pfheighttable),y
   sta.w temp1
 endif
 ifconst PFcolors
   tay
   lda (pfcolortable),y
 ifnconst backgroundchange
   sta COLUPF
 else
   sta COLUBK
 endif
 ifconst pfrowheight
 lda #pfrowheight
 else
 ifnconst pfres
   lda #8
 else
   lda #(96/pfres) ; try to come close to the real size
 endif
 endif
   sta temp1
 endif
 ifnconst PFcolorandheight
 ifnconst PFcolors
 ifnconst PFheights
 ifnconst no_blank_lines
 ; read paddle 0
 ; lo-res paddle read
  ; bit INPT0
  ; bmi paddleskipread
  ; inc paddle0
;donepaddleskip
   sleep 10
 ifconst pfrowheight
   lda #pfrowheight
 else
 ifnconst pfres
   lda #8
 else
   lda #(96/pfres) ; try to come close to the real size
 endif
 endif
   sta temp1
 endif
 endif
 endif
 endif
 

 lda ballheight
 dcp bally
 sbc temp4


 jmp goback


 ifnconst no_blank_lines
lastkernelline
 ifnconst PFcolors
   sleep 10
 else
   ldy #124
   lda (pfcolortable),y
   sta COLUPF
 endif

 ifconst PFheights
 ldx #1
 sleep 4
 else
 ldx playfieldpos
 sleep 3
 endif

 jmp enterlastkernel

 else
lastkernelline
 
 ifconst PFheights
 ldx #1
 sleep 5
 else
   ldx playfieldpos
 sleep 4
 endif

   cpx #1
   bne .enterfromNBL
   jmp no_blank_lines_bailout
 endif

 if ((<*)>$d5)
 align 256
 endif
 ; this is a kludge to prevent page wrapping - fix!!!

.skipDrawlastP1
 sleep 2
 lda #0
 jmp .continuelastP1

.endkerloop ; enter at cycle 59??
 
 nop

.enterfromNBL
 ifconst pfres
 ldy.w playfield+pfres*pfwidth-4
 sty PF1L ;3
 ldy.w playfield+pfres*pfwidth-3-pfadjust
 sty PF2L ;3
 ldy.w playfield+pfres*pfwidth-1
 sty PF1R ; possibly too early?
 ldy.w playfield+pfres*pfwidth-2-pfadjust
 sty PF2R ;3
 else
 ldy.w playfield-48+pfwidth*12+44
 sty PF1L ;3
 ldy.w playfield-48+pfwidth*12+45-pfadjust
 sty PF2L ;3
 ldy.w playfield-48+pfwidth*12+47
 sty PF1R ; possibly too early?
 ldy.w playfield-48+pfwidth*12+46-pfadjust
 sty PF2R ;3
 endif

enterlastkernel
 lda ballheight

; tya
 dcp bally
; sleep 4

; sbc stack3
 rol
 rol
 sta ENABL 

 lda player1height ;3
 dcp player1y ;5
 bcc .skipDrawlastP1
 ldy player1y ;3
 lda (player1pointer),y ;5; player0pointer must be selected carefully by the compiler
			; so it doesn't cross a page boundary!

.continuelastP1
 sta GRP1 ;3

 ifnconst player1colors
   lda missile1height ;3
   dcp missile1y ;5
 else
   lda (player1color),y
   sta COLUP1
 endif

 dex
 ;dec temp4 ; might try putting this above PF writes
 beq endkernel


 ifconst pfres
 ldy.w playfield+pfres*pfwidth-4
 sty PF1L ;3
 ldy.w playfield+pfres*pfwidth-3-pfadjust
 sty PF2L ;3
 ldy.w playfield+pfres*pfwidth-1
 sty PF1R ; possibly too early?
 ldy.w playfield+pfres*pfwidth-2-pfadjust
 sty PF2R ;3
 else
 ldy.w playfield-48+pfwidth*12+44
 sty PF1L ;3
 ldy.w playfield-48+pfwidth*12+45-pfadjust
 sty PF2L ;3
 ldy.w playfield-48+pfwidth*12+47
 sty PF1R ; possibly too early?
 ldy.w playfield-48+pfwidth*12+46-pfadjust
 sty PF2R ;3
 endif

 ifnconst player1colors
   rol;2
   rol;2
   sta ENAM1 ;3
 else
 ifnconst playercolors
   sleep 7
 else
   lda.w player0colorstore
   sta COLUP0
 endif
 endif
 
 lda.w player0height
 dcp player0y
 bcc .skipDrawlastP0
 ldy player0y
 lda (player0pointer),y
.continuelastP0
 sta GRP0



 ifnconst no_blank_lines
   lda missile0height ;3
   dcp missile0y ;5
   sbc stack1
   sta ENAM0 ;3
   jmp .endkerloop
 else
 ifconst readpaddle
   ldy currentpaddle
   lda INPT0,y
   bpl noreadpaddle2
   inc paddle
   jmp .endkerloop
noreadpaddle2
   sleep 4
   jmp .endkerloop
 else ; no_blank_lines and no paddle reading
 pla
 pha ; 14 cycles in 4 bytes
 pla
 pha
 ; sleep 14
 jmp .endkerloop
 endif
 endif


;  ifconst donepaddleskip
;paddleskipread
 ; this is kind of lame, since it requires 4 cycles from a page boundary crossing
 ; plus we get a lo-res paddle read
; bmi donepaddleskip
;  endif

.skipDrawlastP0
 sleep 2
 lda #0
 jmp .continuelastP0

 ifconst no_blank_lines
no_blank_lines_bailout
 ldx #0
 endif

endkernel
 ; 6 digit score routine
 stx PF1
 stx PF2
 stx PF0
 clc

 ifconst pfrowheight
 lda #pfrowheight+2
 else
 ifnconst pfres
   lda #10
 else
   lda #(96/pfres)+2 ; try to come close to the real size
 endif
 endif

 sbc playfieldpos
 sta playfieldpos
 txa

 ifconst shakescreen
   bit shakescreen
   bmi noshakescreen2
   ldx #$3D
noshakescreen2
 endif

   sta WSYNC,x

;                STA WSYNC ;first one, need one more
 sta REFP0
 sta REFP1
                STA GRP0
                STA GRP1
 ;               STA PF1
   ;             STA PF2
 sta HMCLR
 sta ENAM0
 sta ENAM1
 sta ENABL

 lda temp2 ;restore variables that were obliterated by kernel
 sta player0y
 lda temp3
 sta player1y
 ifnconst player1colors
   lda temp6
   sta missile1y
 endif
 ifnconst playercolors
 ifnconst readpaddle
   lda temp5
   sta missile0y
 endif
 endif
 lda stack2
 sta bally

 ifconst no_blank_lines
 sta WSYNC
 endif

 lda INTIM
 clc
 ifnconst vblank_time
 adc #43+12+87
 else
 adc #vblank_time+12+87
 endif
; sta WSYNC
 sta TIM64T

 ifconst minikernel
 jsr minikernel
 endif

 ; now reassign temp vars for score pointers

; score pointers contain:
; score1-5: lo1,lo2,lo3,lo4,lo5,lo6
; swap lo2->temp1
; swap lo4->temp3
; swap lo6->temp5
 ifnconst noscore
 lda scorepointers+1
; ldy temp1
 sta temp1
; sty scorepointers+1

 lda scorepointers+3
; ldy temp3
 sta temp3
; sty scorepointers+3


 sta HMCLR
 tsx
 stx stack1 
 ldx #$E0
 stx HMP0

               LDA scorecolor 
                STA COLUP0
                STA COLUP1
 ifconst pfscore
 lda pfscorecolor
 sta COLUPF
 endif
 sta WSYNC
 ldx #0
                STx GRP0
                STx GRP1 ; seems to be needed because of vdel

 lda scorepointers+5
; ldy temp5
 sta temp5,x
; sty scorepointers+5
 lda #>scoretable
 sta scorepointers+1
 sta scorepointers+3
 sta scorepointers+5
 sta temp2
 sta temp4
 sta temp6
                LDY #7
        STY VDELP0
                STA RESP0
                STA RESP1


        LDA #$03
        STA NUSIZ0
        STA NUSIZ1
        STA VDELP1
        LDA #$F0
        STA HMP1
 lda  (scorepointers),y
 sta  GRP0
                STA HMOVE ; cycle 73 ?
 jmp beginscore


 if ((<*)>$d4)
 align 256 ; kludge that potentially wastes space!  should be fixed!
 endif

loop2
 lda  (scorepointers),y     ;+5  68  204
 sta  GRP0            ;+3  71  213      D1     --      --     --
 ifconst pfscore
 lda.w pfscore1
 sta PF1
 else
 sleep 7
 endif
 ; cycle 0
beginscore
 lda  (scorepointers+$8),y  ;+5   5   15
 sta  GRP1            ;+3   8   24      D1     D1      D2     --
 lda  (scorepointers+$6),y  ;+5  13   39
 sta  GRP0            ;+3  16   48      D3     D1      D2     D2
 lax  (scorepointers+$2),y  ;+5  29   87
 txs
 lax  (scorepointers+$4),y  ;+5  36  108
 sleep 3

 ifconst pfscore
 lda pfscore2
 sta PF1
 else
 sleep 6
 endif

 lda  (scorepointers+$A),y  ;+5  21   63
 stx  GRP1            ;+3  44  132      D3     D3      D4     D2!
 tsx
 stx  GRP0            ;+3  47  141      D5     D3!     D4     D4
 sta  GRP1            ;+3  50  150      D5     D5      D6     D4!
 sty  GRP0            ;+3  53  159      D4*    D5!     D6     D6
 dey
 bpl  loop2           ;+2  60  180

 ldx stack1 
 txs
; lda scorepointers+1
 ldy temp1
; sta temp1
 sty scorepointers+1

                LDA #0   
 sta PF1
               STA GRP0
                STA GRP1
        STA VDELP0
        STA VDELP1;do we need these
        STA NUSIZ0
        STA NUSIZ1

; lda scorepointers+3
 ldy temp3
; sta temp3
 sty scorepointers+3

; lda scorepointers+5
 ldy temp5
; sta temp5
 sty scorepointers+5
 endif ;noscore
 LDA #%11000010
 sta WSYNC
 STA VBLANK
 RETURN

 ifconst shakescreen
doshakescreen
   bit shakescreen
   bmi noshakescreen
   sta WSYNC
noshakescreen
   ldx missile0height
   inx
   rts
 endif

start
 sei
 cld
 ldy #0
 lda $D0
 cmp #$2C               ;check RAM location #1
 bne MachineIs2600
 lda $D1
 cmp #$A9               ;check RAM location #2
 bne MachineIs2600
 dey
MachineIs2600
 ldx #0
 txa
clearmem
 inx
 txs
 pha
 bne clearmem
 sty temp1
 ifconst pfrowheight
 lda pfrowheight
 else
 ifconst pfres
 lda #(96/pfres)
 else
 lda #8
 endif
 endif
 sta playfieldpos
 ldx #5
initscore
 lda #<scoretable
 sta scorepointers,x 
 dex
 bpl initscore
 lda #1
 sta CTRLPF
 ora INTIM
 sta rand

 ifconst multisprite
   jsr multisprite_setup
 endif

 ifnconst bankswitch
   jmp game
 else
   lda #>(game-1)
   pha
   lda #<(game-1)
   pha
   pha
   pha
   ldx #1
   jmp BS_jsr
 endif
; playfield drawing routines
; you get a 32x12 bitmapped display in a single color :)
; 0-31 and 0-11

pfclear ; clears playfield - or fill with pattern
 ifconst pfres
 ldx #pfres*pfwidth-1
 else
 ldx #47-(4-pfwidth)*12 ; will this work?
 endif
pfclear_loop
 ifnconst superchip
 sta playfield,x
 else
 sta playfield-128,x
 endif
 dex
 bpl pfclear_loop
 RETURN
 
setuppointers
 stx temp2 ; store on.off.flip value
 tax ; put x-value in x 
 lsr
 lsr
 lsr ; divide x pos by 8 
 sta temp1
 tya
 asl
 if pfwidth=4
  asl ; multiply y pos by 4
 endif ; else multiply by 2
 clc
 adc temp1 ; add them together to get actual memory location offset
 tay ; put the value in y
 lda temp2 ; restore on.off.flip value
 rts

pfread
;x=xvalue, y=yvalue
 jsr setuppointers
 lda setbyte,x
 and playfield,y
 eor setbyte,x
; beq readzero
; lda #1
; readzero
 RETURN

pfpixel
;x=xvalue, y=yvalue, a=0,1,2
 jsr setuppointers

 ifconst bankswitch
 lda temp2 ; load on.off.flip value (0,1, or 2)
 beq pixelon_r  ; if "on" go to on
 lsr
 bcs pixeloff_r ; value is 1 if true
 lda playfield,y ; if here, it's "flip"
 eor setbyte,x
 ifconst superchip
 sta playfield-128,y
 else
 sta playfield,y
 endif
 RETURN
pixelon_r
 lda playfield,y
 ora setbyte,x
 ifconst superchip
 sta playfield-128,y
 else
 sta playfield,y
 endif
 RETURN
pixeloff_r
 lda setbyte,x
 eor #$ff
 and playfield,y
 ifconst superchip
 sta playfield-128,y
 else
 sta playfield,y
 endif
 RETURN

 else
 jmp plotpoint
 endif

pfhline
;x=xvalue, y=yvalue, a=0,1,2, temp3=endx
 jsr setuppointers
 jmp noinc
keepgoing
 inx
 txa
 and #7
 bne noinc
 iny
noinc
 jsr plotpoint
 cpx temp3
 bmi keepgoing
 RETURN

pfvline
;x=xvalue, y=yvalue, a=0,1,2, temp3=endx
 jsr setuppointers
 sty temp1 ; store memory location offset
 inc temp3 ; increase final x by 1 
 lda temp3
 asl
 if pfwidth=4
   asl ; multiply by 4
 endif ; else multiply by 2
 sta temp3 ; store it
 ; Thanks to Michael Rideout for fixing a bug in this code
 ; right now, temp1=y=starting memory location, temp3=final
 ; x should equal original x value
keepgoingy
 jsr plotpoint
 iny
 iny
 if pfwidth=4
   iny
   iny
 endif
 cpy temp3
 bmi keepgoingy
 RETURN

plotpoint
 lda temp2 ; load on.off.flip value (0,1, or 2)
 beq pixelon  ; if "on" go to on
 lsr
 bcs pixeloff ; value is 1 if true
 lda playfield,y ; if here, it's "flip"
 eor setbyte,x
  ifconst superchip
 sta playfield-128,y
 else
 sta playfield,y
 endif
 rts
pixelon
 lda playfield,y
 ora setbyte,x
 ifconst superchip
 sta playfield-128,y
 else
 sta playfield,y
 endif
 rts
pixeloff
 lda setbyte,x
 eor #$ff
 and playfield,y
 ifconst superchip
 sta playfield-128,y
 else
 sta playfield,y
 endif
 rts

setbyte
 ifnconst pfcenter
 .byte $80
 .byte $40
 .byte $20
 .byte $10
 .byte $08
 .byte $04
 .byte $02
 .byte $01
 endif
 .byte $01
 .byte $02
 .byte $04
 .byte $08
 .byte $10
 .byte $20
 .byte $40
 .byte $80
 .byte $80
 .byte $40
 .byte $20
 .byte $10
 .byte $08
 .byte $04
 .byte $02
 .byte $01
 .byte $01
 .byte $02
 .byte $04
 .byte $08
 .byte $10
 .byte $20
 .byte $40
 .byte $80
pfscroll ;(a=0 left, 1 right, 2 up, 4 down, 6=upup, 12=downdown)
 bne notleft
;left
 ifconst pfres
 ldx #pfres*4
 else
 ldx #48
 endif
leftloop
 lda playfield-1,x
 lsr

 ifconst superchip
 lda playfield-2,x
 rol
 sta playfield-130,x
 lda playfield-3,x
 ror
 sta playfield-131,x
 lda playfield-4,x
 rol
 sta playfield-132,x
 lda playfield-1,x
 ror
 sta playfield-129,x
 else
 rol playfield-2,x
 ror playfield-3,x
 rol playfield-4,x
 ror playfield-1,x
 endif

 txa
 sbx #4
 bne leftloop
 RETURN

notleft
 lsr
 bcc notright
;right

 ifconst pfres
 ldx #pfres*4
 else
 ldx #48
 endif
rightloop
 lda playfield-4,x
 lsr
 ifconst superchip
 lda playfield-3,x
 rol
 sta playfield-131,x
 lda playfield-2,x
 ror
 sta playfield-130,x
 lda playfield-1,x
 rol
 sta playfield-129,x
 lda playfield-4,x
 ror
 sta playfield-132,x
 else
 rol playfield-3,x
 ror playfield-2,x
 rol playfield-1,x
 ror playfield-4,x
 endif
 txa
 sbx #4
 bne rightloop
  RETURN

notright
 lsr
 bcc notup
;up
 lsr
 bcc onedecup
 dec playfieldpos
onedecup
 dec playfieldpos
 beq shiftdown 
 bpl noshiftdown2 
shiftdown
  ifconst pfrowheight
 lda #pfrowheight
 else
 ifnconst pfres
   lda #8
 else
   lda #(96/pfres) ; try to come close to the real size
 endif
 endif

 sta playfieldpos
 lda playfield+3
 sta temp4
 lda playfield+2
 sta temp3
 lda playfield+1
 sta temp2
 lda playfield
 sta temp1
 ldx #0
up2
 lda playfield+4,x
 ifconst superchip
 sta playfield-128,x
 lda playfield+5,x
 sta playfield-127,x
 lda playfield+6,x
 sta playfield-126,x
 lda playfield+7,x
 sta playfield-125,x
 else
 sta playfield,x
 lda playfield+5,x
 sta playfield+1,x
 lda playfield+6,x
 sta playfield+2,x
 lda playfield+7,x
 sta playfield+3,x
 endif
 txa
 sbx #252
 ifconst pfres
 cpx #(pfres-1)*4
 else
 cpx #44
 endif
 bne up2

 lda temp4
 
 ifconst superchip
 ifconst pfres
 sta playfield+pfres*4-129
 lda temp3
 sta playfield+pfres*4-130
 lda temp2
 sta playfield+pfres*4-131
 lda temp1
 sta playfield+pfres*4-132
 else
 sta playfield+47-128
 lda temp3
 sta playfield+46-128
 lda temp2
 sta playfield+45-128
 lda temp1
 sta playfield+44-128
 endif
 else
 ifconst pfres
 sta playfield+pfres*4-1
 lda temp3
 sta playfield+pfres*4-2
 lda temp2
 sta playfield+pfres*4-3
 lda temp1
 sta playfield+pfres*4-4
 else
 sta playfield+47
 lda temp3
 sta playfield+46
 lda temp2
 sta playfield+45
 lda temp1
 sta playfield+44
 endif
 endif
noshiftdown2
 RETURN


notup
;down
 lsr
 bcs oneincup
 inc playfieldpos
oneincup
 inc playfieldpos
 lda playfieldpos

  ifconst pfrowheight
 cmp #pfrowheight+1
 else
 ifnconst pfres
   cmp #9
 else
   cmp #(96/pfres)+1 ; try to come close to the real size
 endif
 endif

 bcc noshiftdown 
 lda #1
 sta playfieldpos

 ifconst pfres
 lda playfield+pfres*4-1
 sta temp4
 lda playfield+pfres*4-2
 sta temp3
 lda playfield+pfres*4-3
 sta temp2
 lda playfield+pfres*4-4
 else
 lda playfield+47
 sta temp4
 lda playfield+46
 sta temp3
 lda playfield+45
 sta temp2
 lda playfield+44
 endif

 sta temp1

 ifconst pfres
 ldx #(pfres-1)*4
 else
 ldx #44
 endif
down2
 lda playfield-1,x
 ifconst superchip
 sta playfield-125,x
 lda playfield-2,x
 sta playfield-126,x
 lda playfield-3,x
 sta playfield-127,x
 lda playfield-4,x
 sta playfield-128,x
 else
 sta playfield+3,x
 lda playfield-2,x
 sta playfield+2,x
 lda playfield-3,x
 sta playfield+1,x
 lda playfield-4,x
 sta playfield,x
 endif
 txa
 sbx #4
 bne down2

 lda temp4
 ifconst superchip
 sta playfield-125
 lda temp3
 sta playfield-126
 lda temp2
 sta playfield-127
 lda temp1
 sta playfield-128
 else
 sta playfield+3
 lda temp3
 sta playfield+2
 lda temp2
 sta playfield+1
 lda temp1
 sta playfield
 endif
noshiftdown
 RETURN
;standard routines needed for pretty much all games
; just the random number generator is left - maybe we should remove this asm file altogether?
; repositioning code and score pointer setup moved to overscan
; read switches, joysticks now compiler generated (more efficient)

randomize
	lda rand
	lsr
 ifconst rand16
	rol rand16
 endif
	bcc noeor
	eor #$B4
noeor
	sta rand
 ifconst rand16
	eor rand16
 endif
	RETURN
drawscreen
 ifconst debugscore
   ldx #14
   lda INTIM ; display # cycles left in the score

 ifconst mincycles
 lda mincycles 
 cmp INTIM
 lda mincycles
 bcc nochange
 lda INTIM
 sta mincycles
nochange
 endif

;   cmp #$2B
;   bcs no_cycles_left
   bmi cycles_left
   ldx #64
   eor #$ff ;make negative
cycles_left
   stx scorecolor
   and #$7f ; clear sign bit
   tax
   lda scorebcd,x
   sta score+2
   lda scorebcd1,x
   sta score+1
   jmp done_debugscore   
scorebcd
 .byte $00, $64, $28, $92, $56, $20, $84, $48, $12, $76, $40
 .byte $04, $68, $32, $96, $60, $24, $88, $52, $16, $80, $44
 .byte $08, $72, $36, $00, $64, $28, $92, $56, $20, $84, $48
 .byte $12, $76, $40, $04, $68, $32, $96, $60, $24, $88
scorebcd1
 .byte 0, 0, 1, 1, 2, 3, 3, 4, 5, 5, 6
 .byte 7, 7, 8, 8, 9, $10, $10, $11, $12, $12, $13
 .byte $14, $14, $15, $16, $16, $17, $17, $18, $19, $19, $20
 .byte $21, $21, $22, $23, $23, $24, $24, $25, $26, $26
done_debugscore
 endif

 ifconst debugcycles
   lda INTIM ; if we go over, it mucks up the background color
;   cmp #$2B
;   BCC overscan
   bmi overscan
   sta COLUBK
   bcs doneoverscan
 endif

 
overscan
 lda INTIM ;wait for sync
 bmi overscan
doneoverscan
;do VSYNC
 lda #2
 sta WSYNC
 sta VSYNC
 STA WSYNC
 STA WSYNC
 LDA #0
 STA WSYNC
 STA VSYNC
 sta VBLANK
 ifnconst overscan_time
 lda #37+128
 else
 lda #overscan_time+128
 endif
 sta TIM64T

 ifconst legacy
 if legacy < 100
 ldx #4
adjustloop
 lda player0x,x
 sec
 sbc #14 ;?
 sta player0x,x
 dex
 bpl adjustloop
 endif
 endif
 if (<*)>$F0
 ;align 256, $ea
 ; the above puts in zeros. Why? replaced by repeat below:
 repeat ($100-(<*))
 nop
 repend
 endif
  sta WSYNC
  ldx #4
  SLEEP 3
HorPosLoop       ;     5
  lda player0x,X  ;+4   9
  sec           ;+2  11
DivideLoop
  sbc #15
  bcs DivideLoop;+4  15
  sta temp1,X    ;+4  19
  sta RESP0,X   ;+4  23
  sta WSYNC
  dex
  bpl HorPosLoop;+5   5
                ;     4

  ldx #4
  ldy temp1,X
  lda repostable-256,Y
  sta HMP0,X    ;+14 18

  dex
  ldy temp1,X
  lda repostable-256,Y
  sta HMP0,X    ;+14 32

  dex
  ldy temp1,X
  lda repostable-256,Y
  sta HMP0,X    ;+14 46

  dex
  ldy temp1,X
  lda repostable-256,Y
  sta HMP0,X    ;+14 60

  dex
  ldy temp1,X
  lda repostable-256,Y
  sta HMP0,X    ;+14 74

  sta WSYNC
 
  sta HMOVE     ;+3   3


 ifconst legacy
 if legacy < 100
 ldx #4
adjustloop2
 lda player0x,x
 clc
 adc #14 ;?
 sta player0x,x
 dex
 bpl adjustloop2
 endif
 endif




;set score pointers
 lax score+2
 jsr scorepointerset
 sty scorepointers+5
 stx scorepointers+2
 lax score+1
 jsr scorepointerset
 sty scorepointers+4
 stx scorepointers+1
 lax score
 jsr scorepointerset
 sty scorepointers+3
 stx scorepointers

vblk
; run possible vblank bB code
 ifconst vblank_bB_code
   jsr vblank_bB_code
 endif
vblk2
 LDA INTIM
 bmi vblk2
 jmp kernel
 

    .byte $80,$70,$60,$50,$40,$30,$20,$10,$00
    .byte $F0,$E0,$D0,$C0,$B0,$A0,$90
repostable

scorepointerset
 and #$0F
 asl
 asl
 asl
 adc #<scoretable
 tay 
 txa
 arr #$F0
 tax
 sbx #<(256-<scoretable)
 rts
game
.L00 ;  set kernel_options pfcolors no_blank_lines background

.L01 ;  rem future ideas: 

.L02 ;  rem - title screen

.L03 ;  rem - more blocks

.
 ; 

.L04 ;  dim _GameState  =  a

;._EvDir._GameState{1}.
.L05 ;  def _EvDir = _GameState{1}

;._Debounce._GameState{2}.
.L06 ;  def _Debounce = _GameState{2}

.L07 ;  dim _Species  =  b

.L08 ;  dim _InputCounter  =  c

.L09 ;  dim _AnimFrame  =  d

.L010 ;  dim _GarbageLevel  =  e

.L011 ;  dim _GarbageProb  =  f

.L012 ;  dim _GarbageFrame  =  g

.L013 ;  dim _Level  =  l

.L014 ;  dim _SoundEffect  =  s

.L015 ;  dim _SoundCounter  =  t

.L016 ;  dim _Speed  =  w

.L017 ;  rem x, y - position

.
 ; 

.L018 ;  rem title

.L019 ;  dim _TitleColor  =  z

.
 ; 

.L020 ;  dim sc1  =  score

.L021 ;  dim sc2  =  score  +  1

.L022 ;  dim sc3  =  score  +  2

.
 ; 

.L023 ;  const Y_SKY  =  30

.L024 ;  const Y_GROUND  =  61

.L025 ;  const Y_TOP  =  3

.L026 ;  const Y_BOTTOM  =  87

.L027 ;  const X_LEFT  =  15

.L028 ;  const X_RIGHT  =  110

.
 ; 

.L029 ;  const SND_NONE  =  0

.L030 ;  const SND_EVOLVE_UP  =  1

.L031 ;  const SND_EVOLVE_DOWN  =  2

.L032 ;  const SND_DIE  =  3

.L033 ;  const SND_LEVELUP  =  4

.
 ; 

.L034 ;  const MAX_SPEED  =  9

.L035 ;  const MIN_SPEED  =  2

.L036 ;  const MIN_GARBAGE  =  2

.L037 ;  const MAX_GARBAGE  =  3

.L038 ;  const MIN_GARBAGEPROB  =  3

.L039 ;  const MAX_GARBAGEPROB  =  6

.L040 ;  rem initialize colours

.L041 ;  pfcolors:

 lda # $8E
 sta COLUPF
 ifconst pfres
 lda #>(pfcolorlabel13-132+pfres*pfwidth)
 else
 lda #>(pfcolorlabel13-84)
 endif
 sta pfcolortable+1
 ifconst pfres
 lda #<(pfcolorlabel13-132+pfres*pfwidth)
 else
 lda #<(pfcolorlabel13-84)
 endif
 sta pfcolortable
.
 ; 

.L042 ;  scorecolor  =  $0e

	LDA #$0e
	STA scorecolor
.L043 ;  COLUP0  =  $00

	LDA #$00
	STA COLUP0
.L044 ;  COLUP1  =  $00

	LDA #$00
	STA COLUP1
.L045 ;  _SoundEffect  =  0

	LDA #0
	STA _SoundEffect
.
 ; 

.title
 ; title

.L046 ;  player1y  =  128

	LDA #128
	STA player1y
.L047 ;  COLUPF  =  _TitleColor

	LDA _TitleColor
	STA COLUPF
.L048 ;  _TitleColor  =  _TitleColor  +  1

	INC _TitleColor
.L049 ;  temp1  =  rand

 jsr randomize
	STA temp1
.L050 ;  playfield:

  ifconst pfres
	  ldx #(11>pfres)*(pfres*pfwidth-1)+(11<=pfres)*43
  else
	  ldx #43
  endif
	jmp pflabel0
PF_data0
	.byte %11101010, %00010010, %10101110, %10010000
	.byte %10001010, %00010101, %10101000, %10010000
	.byte %11001010, %00010101, %10101100, %10010000
	.byte %10001010, %00010101, %10101000, %10010000
	.byte %11100100, %01110010, %01001110, %01100000
	.byte %00000000, %00000000, %00000000, %00000000
	.byte %00001110, %11001001, %01001011, %00001101
	.byte %00001000, %00101001, %01010010, %00010100
	.byte %00001100, %00101001, %01100011, %00001100
	.byte %00001000, %00101001, %01010010, %00010100
	.byte %00001000, %11000110, %01001011, %00010101
pflabel0
	lda PF_data0,x
	sta playfield,x
	dex
	bpl pflabel0
.
 ; 

.L051 ;  if joy0fire  &&  !_Debounce then goto start

 bit INPT4
	BMI .skipL051
.condpart0
	LDA _GameState
	AND #4
	BNE .skip0then
.condpart1
 jmp .start

.skip0then
.skipL051
.L052 ;  if !joy0fire then _Debounce  =  0

 bit INPT4
	BPL .skipL052
.condpart2
	LDA _GameState
	AND #251
	STA _GameState
.skipL052
.L053 ;  drawscreen

 jsr drawscreen
.L054 ;  gosub doSound

 jsr .doSound

.L055 ;  goto title

 jmp .title

.
 ; 

.start
 ; start

.L056 ;  pfclear

	LDA #0
 jsr pfclear
.L057 ;  COLUPF  =  $00

	LDA #$00
	STA COLUPF
.L058 ;  score  =  0

	LDA #$00
	STA score+2
	LDA #$00
	STA score+1
	LDA #$00
	STA score
.L059 ;  _GameState  =  0

	LDA #0
	STA _GameState
.L060 ;  _GarbageFrame  =  0

	LDA #0
	STA _GarbageFrame
.L061 ;  _Level  =  0

	LDA #0
	STA _Level
.L062 ;  _Speed  =  MAX_SPEED

	LDA #MAX_SPEED
	STA _Speed
.L063 ;  _GarbageProb  =  MIN_GARBAGEPROB

	LDA #MIN_GARBAGEPROB
	STA _GarbageProb
.L064 ;  _GarbageLevel  =  MAX_GARBAGE

	LDA #MAX_GARBAGE
	STA _GarbageLevel
.L065 ;  if joy0fire then _Debounce  =  1

 bit INPT4
	BMI .skipL065
.condpart3
	LDA _GameState
	ORA #4
	STA _GameState
.skipL065
.L066 ;  x = 30  :  y  =  75

	LDA #30
	STA x
	LDA #75
	STA y
.L067 ;  _Species  =  0

	LDA #0
	STA _Species
.
 ; 

.gameloop
 ; gameloop

.L068 ;  temp2  =  _Level

	LDA _Level
	STA temp2
.L069 ;  _Level  =  sc2

	LDA sc2
	STA _Level
.L070 ;  if _Level  <  temp2 then _Level  =  temp2

	LDA _Level
	CMP temp2
     BCS .skipL070
.condpart4
	LDA temp2
	STA _Level
.skipL070
.L071 ;  if temp2  <>  _Level then _SoundEffect  =  SND_LEVELUP  :  _SoundCounter  =  0  :  _GarbageFrame  =  0

	LDA temp2
	CMP _Level
     BEQ .skipL071
.condpart5
	LDA #SND_LEVELUP
	STA _SoundEffect
	LDA #0
	STA _SoundCounter
	STA _GarbageFrame
.skipL071
.L072 ;  if _Speed  >  MIN_SPEED then _Speed  =  MAX_SPEED  -  _Level

	LDA #MIN_SPEED
	CMP _Speed
     BCS .skipL072
.condpart6
	LDA #MAX_SPEED
	SEC
	SBC _Level
	STA _Speed
.skipL072
.L073 ;  temp1  =  _Level  /  2

	LDA _Level
	lsr
	STA temp1
.L074 ;  if _GarbageProb  <  MAX_GARBAGEPROB then _GarbageProb  =  MIN_GARBAGEPROB  +  temp1

	LDA _GarbageProb
	CMP #MAX_GARBAGEPROB
     BCS .skipL074
.condpart7
	LDA #MIN_GARBAGEPROB
	CLC
	ADC temp1
	STA _GarbageProb
.skipL074
.
 ; 

.L075 ;  _AnimFrame  =  _AnimFrame  +  1

	INC _AnimFrame
.L076 ;  if _GarbageFrame  =  0 then score  =  score  +  1

	LDA _GarbageFrame
	CMP #0
     BNE .skipL076
.condpart8
	SED
	CLC
	LDA score+2
	ADC #$01
	STA score+2
	LDA score+1
	ADC #$00
	STA score+1
	LDA score
	ADC #$00
	STA score
	CLD
.skipL076
.L077 ;  _GarbageFrame  =  _GarbageFrame  +  1

	INC _GarbageFrame
.L078 ;  if _GarbageFrame  =  _Speed then gosub destroyGarbage

	LDA _GarbageFrame
	CMP _Speed
     BNE .skipL078
.condpart9
 jsr .destroyGarbage

.skipL078
.L079 ;  temp1  =  _Speed  +  1

	LDA _Speed
	CLC
	ADC #1
	STA temp1
.L080 ;  if _GarbageFrame  =  temp1 then gosub createGarbage

	LDA _GarbageFrame
	CMP temp1
     BNE .skipL080
.condpart10
 jsr .createGarbage

.skipL080
.L081 ;  temp1  =  _Speed  +  2

	LDA _Speed
	CLC
	ADC #2
	STA temp1
.L082 ;  if _GarbageFrame  =  temp1 then pfscroll left  :  _GarbageFrame  =  0

	LDA _GarbageFrame
	CMP temp1
     BNE .skipL082
.condpart11
	LDA #0
 jsr pfscroll
	LDA #0
	STA _GarbageFrame
.skipL082
.
 ; 

.L083 ;  player1x = x

	LDA x
	STA player1x
.L084 ;  player1y = y

	LDA y
	STA player1y
.L085 ;  if _Species  =  0 then goto doFish

	LDA _Species
	CMP #0
     BNE .skipL085
.condpart12
 jmp .doFish

.skipL085
.L086 ;  if _Species  =  1 then goto doLizard

	LDA _Species
	CMP #1
     BNE .skipL086
.condpart13
 jmp .doLizard

.skipL086
.doBird
 ; doBird

.L087 ;  if _AnimFrame  >  14 then _AnimFrame  =  0

	LDA #14
	CMP _AnimFrame
     BCS .skipL087
.condpart14
	LDA #0
	STA _AnimFrame
.skipL087
.L088 ;  if _AnimFrame  >  7 then goto drawBirdFrame2

	LDA #7
	CMP _AnimFrame
     BCS .skipL088
.condpart15
 jmp .drawBirdFrame2

.skipL088
.L089 ;  player1:

	LDA #<playerL089_1

	STA player1pointerlo
	LDA #>playerL089_1

	STA player1pointerhi
	LDA #2
	STA player1height
.L090 ;  goto handleInputBird

 jmp .handleInputBird

.drawBirdFrame2
 ; drawBirdFrame2

.L091 ;  player1:

	LDA #<playerL091_1

	STA player1pointerlo
	LDA #>playerL091_1

	STA player1pointerhi
	LDA #2
	STA player1height
.handleInputBird
 ; handleInputBird

.L092 ;  if y  <  Y_SKY then goto handleInputFast

	LDA y
	CMP #Y_SKY
     BCS .skipL092
.condpart16
 jmp .handleInputFast

.skipL092
.L093 ;  if y  <  Y_GROUND then goto handleInputSlow

	LDA y
	CMP #Y_GROUND
     BCS .skipL093
.condpart17
 jmp .handleInputSlow

.skipL093
.L094 ;  goto die

 jmp .die

.
 ; 

.doFish
 ; doFish

.L095 ;  if _AnimFrame  >  20 then _AnimFrame  =  0

	LDA #20
	CMP _AnimFrame
     BCS .skipL095
.condpart18
	LDA #0
	STA _AnimFrame
.skipL095
.L096 ;  if _AnimFrame  >  10 then goto drawFishFrame2

	LDA #10
	CMP _AnimFrame
     BCS .skipL096
.condpart19
 jmp .drawFishFrame2

.skipL096
.L097 ;  player1:

	LDA #<playerL097_1

	STA player1pointerlo
	LDA #>playerL097_1

	STA player1pointerhi
	LDA #3
	STA player1height
.L098 ;  goto handleInputFish

 jmp .handleInputFish

.drawFishFrame2
 ; drawFishFrame2

.L099 ;  player1:

	LDA #<playerL099_1

	STA player1pointerlo
	LDA #>playerL099_1

	STA player1pointerhi
	LDA #3
	STA player1height
.handleInputFish
 ; handleInputFish

.L0100 ;  if y  <  Y_GROUND then goto die

	LDA y
	CMP #Y_GROUND
     BCS .skipL0100
.condpart20
 jmp .die

.skipL0100
.L0101 ;  goto handleInputFast

 jmp .handleInputFast

.
 ; 

.doLizard
 ; doLizard

.L0102 ;  if _AnimFrame  >  10 then _AnimFrame  =  0

	LDA #10
	CMP _AnimFrame
     BCS .skipL0102
.condpart21
	LDA #0
	STA _AnimFrame
.skipL0102
.L0103 ;  if _AnimFrame  >  5 then goto drawLizardFrame2

	LDA #5
	CMP _AnimFrame
     BCS .skipL0103
.condpart22
 jmp .drawLizardFrame2

.skipL0103
.L0104 ;  player1:

	LDA #<playerL0104_1

	STA player1pointerlo
	LDA #>playerL0104_1

	STA player1pointerhi
	LDA #4
	STA player1height
.L0105 ;  goto handleInputLizard

 jmp .handleInputLizard

.drawLizardFrame2
 ; drawLizardFrame2

.L0106 ;  player1:

	LDA #<playerL0106_1

	STA player1pointerlo
	LDA #>playerL0106_1

	STA player1pointerhi
	LDA #4
	STA player1height
.
 ; 

.handleInputLizard
 ; handleInputLizard

.L0107 ;  if y  <  Y_SKY then goto handleInputFall

	LDA y
	CMP #Y_SKY
     BCS .skipL0107
.condpart23
 jmp .handleInputFall

.skipL0107
.L0108 ;  if y  <  Y_GROUND then goto handleInputFast

	LDA y
	CMP #Y_GROUND
     BCS .skipL0108
.condpart24
 jmp .handleInputFast

.skipL0108
.handleInputSlow
 ; handleInputSlow

.L0109 ;  _InputCounter  =  _InputCounter  +  1

	INC _InputCounter
.L0110 ;  if _InputCounter  <  3 then goto handleInputCommon

	LDA _InputCounter
	CMP #3
     BCS .skipL0110
.condpart25
 jmp .handleInputCommon

.skipL0110
.L0111 ;  _InputCounter  =  0

	LDA #0
	STA _InputCounter
.handleInputFast
 ; handleInputFast

.L0112 ;  if joy0up then y = y - 1

 lda #$10
 bit SWCHA
	BNE .skipL0112
.condpart26
	DEC y
.skipL0112
.L0113 ;  if joy0down then y = y + 1

 lda #$20
 bit SWCHA
	BNE .skipL0113
.condpart27
	INC y
.skipL0113
.handleInputLeftRight
 ; handleInputLeftRight

.L0114 ;  if joy0right then x = x + 1

 bit SWCHA
	BMI .skipL0114
.condpart28
	INC x
.skipL0114
.L0115 ;  if joy0left then x = x - 1

 bit SWCHA
	BVS .skipL0115
.condpart29
	DEC x
.skipL0115
.handleInputCommon
 ; handleInputCommon

.L0116 ;  if joy0right then REFP1  =  0

 bit SWCHA
	BMI .skipL0116
.condpart30
	LDA #0
	STA REFP1
.skipL0116
.L0117 ;  if joy0left then REFP1  =  8

 bit SWCHA
	BVS .skipL0117
.condpart31
	LDA #8
	STA REFP1
.skipL0117
.L0118 ;  if y  <  Y_TOP then y  =  Y_TOP

	LDA y
	CMP #Y_TOP
     BCS .skipL0118
.condpart32
	LDA #Y_TOP
	STA y
.skipL0118
.L0119 ;  if y  >  Y_BOTTOM then y  =  Y_BOTTOM

	LDA #Y_BOTTOM
	CMP y
     BCS .skipL0119
.condpart33
	LDA #Y_BOTTOM
	STA y
.skipL0119
.L0120 ;  if x  <  X_LEFT then x  =  X_LEFT

	LDA x
	CMP #X_LEFT
     BCS .skipL0120
.condpart34
	LDA #X_LEFT
	STA x
.skipL0120
.L0121 ;  if x  >  X_RIGHT then x  =  X_RIGHT

	LDA #X_RIGHT
	CMP x
     BCS .skipL0121
.condpart35
	LDA #X_RIGHT
	STA x
.skipL0121
.L0122 ;  if joy0fire then gosub evolve else _Debounce  =  0

 bit INPT4
	BMI .skipL0122
.condpart36
 jsr .evolve
 jmp .skipelse0
.skipL0122
	LDA _GameState
	AND #251
	STA _GameState
.skipelse0
.
 ; 

.doDraw
 ; doDraw

.L0123 ;  player1x = x  :  player1y = y

	LDA x
	STA player1x
	LDA y
	STA player1y
.L0124 ;  drawscreen

 jsr drawscreen
.L0125 ;  gosub doSound

 jsr .doSound

.L0126 ;  if collision(player1,playfield) then goto die

	BIT CXP1FB
	BPL .skipL0126
.condpart37
 jmp .die

.skipL0126
.L0127 ;  goto gameloop

 jmp .gameloop

.
 ; 

.handleInputFall
 ; handleInputFall

.L0128 ;  y  =  y  +  1

	INC y
.L0129 ;  goto handleInputLeftRight

 jmp .handleInputLeftRight

.
 ; 

.evolve
 ; evolve

.L0130 ;  if _Debounce then return

	LDA _GameState
	AND #4
	BEQ .skipL0130
.condpart38
	RTS
.skipL0130
.L0131 ;  _Debounce  =  1

	LDA _GameState
	ORA #4
	STA _GameState
.L0132 ;  _SoundCounter  =  0

	LDA #0
	STA _SoundCounter
.L0133 ;  if _Species  =  0 then _Species  =  1 :  _EvDir  =  1 :  _SoundEffect  =  SND_EVOLVE_UP  :  return

	LDA _Species
	CMP #0
     BNE .skipL0133
.condpart39
	LDA #1
	STA _Species
	LDA _GameState
	ORA #2
	STA _GameState
	LDA #SND_EVOLVE_UP
	STA _SoundEffect
	RTS
.skipL0133
.L0134 ;  if _Species  =  1  &&  _EvDir then _Species  =  2 :  _SoundEffect  =  SND_EVOLVE_UP  :  return

	LDA _Species
	CMP #1
     BNE .skipL0134
.condpart40
	LDA _GameState
	AND #2
	BEQ .skip40then
.condpart41
	LDA #2
	STA _Species
	LDA #SND_EVOLVE_UP
	STA _SoundEffect
	RTS
.skip40then
.skipL0134
.L0135 ;  if _Species  =  1 then _Species  =  0  :  _SoundEffect  =  SND_EVOLVE_DOWN  :  return

	LDA _Species
	CMP #1
     BNE .skipL0135
.condpart42
	LDA #0
	STA _Species
	LDA #SND_EVOLVE_DOWN
	STA _SoundEffect
	RTS
.skipL0135
.L0136 ;  _EvDir  =  0  :  _Species  =  1  :  _SoundEffect  =  SND_EVOLVE_DOWN  :  return

	LDA _GameState
	AND #253
	STA _GameState
	LDA #1
	STA _Species
	LDA #SND_EVOLVE_DOWN
	STA _SoundEffect
	RTS
.
 ; 

.createGarbage
 ; createGarbage

.L0137 ;  temp2  =  rand  &  7

 jsr randomize
	AND #7
	STA temp2
.L0138 ;  if temp2  >  _GarbageProb then return

	LDA _GarbageProb
	CMP temp2
     BCS .skipL0138
.condpart43
	RTS
.skipL0138
;._GarbageCount.temp4.
.L0139 ;  def _GarbageCount = temp4

;._GarbageY.temp3.
.L0140 ;  def _GarbageY = temp3

.L0141 ;  _GarbageCount  =  _GarbageLevel

	LDA _GarbageLevel
	STA temp4
.garbageLoop
 ; garbageLoop

.L0142 ;  _GarbageCount  =  _GarbageCount  -  1

	DEC temp4
.L0143 ;  if _GarbageCount  =  0 then return

	LDA temp4
	CMP #0
     BNE .skipL0143
.condpart44
	RTS
.skipL0143
.L0144 ;  _GarbageY  =   ( rand  &  15 ) 

; complex statement detected
 jsr randomize
	AND #15
	STA temp3
.L0145 ;  if _GarbageY  <=  11 then pfpixel 31 _GarbageY on

	LDA #11
	CMP temp3
     BCC .skipL0145
.condpart45
	LDA #31
	LDY temp3
	LDX #0
 jsr pfpixel
.skipL0145
.L0146 ;  goto garbageLoop

 jmp .garbageLoop

.
 ; 

.destroyGarbage
 ; destroyGarbage

.L0147 ;  _GarbageY  =  11

	LDA #11
	STA temp3
.destroyGarbageLoop
 ; destroyGarbageLoop

.L0148 ;  pfpixel 0 _GarbageY off

	LDA #0
	LDY temp3
	LDX #1
 jsr pfpixel
.L0149 ;  if _GarbageY  =  0 then return

	LDA temp3
	CMP #0
     BNE .skipL0149
.condpart46
	RTS
.skipL0149
.L0150 ;  _GarbageY  =  _GarbageY  -  1

	DEC temp3
.L0151 ;  goto destroyGarbageLoop

 jmp .destroyGarbageLoop

.
 ; 

.die
 ; die

.L0152 ;  _SoundEffect  =  SND_DIE

	LDA #SND_DIE
	STA _SoundEffect
.L0153 ;  _SoundCounter  =  0

	LDA #0
	STA _SoundCounter
.L0154 ;  goto title

 jmp .title

.
 ; 

.doSound
 ; doSound

.L0155 ;  if _SoundEffect  =  0 then AUDV0  =  0  :  return

	LDA _SoundEffect
	CMP #0
     BNE .skipL0155
.condpart47
	LDA #0
	STA AUDV0
	RTS
.skipL0155
.L0156 ;  if _SoundEffect  =  SND_EVOLVE_UP then AUDV0  =  8  :  AUDC0  =  3  :  AUDF0  =  31  -  _SoundCounter

	LDA _SoundEffect
	CMP #SND_EVOLVE_UP
     BNE .skipL0156
.condpart48
	LDA #8
	STA AUDV0
	LDA #3
	STA AUDC0
	LDA #31
	SEC
	SBC _SoundCounter
	STA AUDF0
.skipL0156
.L0157 ;  if _SoundEffect  =  SND_EVOLVE_DOWN then AUDV0  =  8  :  AUDC0  =  3  :  AUDF0  =  _SoundCounter

	LDA _SoundEffect
	CMP #SND_EVOLVE_DOWN
     BNE .skipL0157
.condpart49
	LDA #8
	STA AUDV0
	LDA #3
	STA AUDC0
	LDA _SoundCounter
	STA AUDF0
.skipL0157
.L0158 ;  if _SoundEffect  =  SND_DIE then AUDV0  =  8  :  AUDC0  =  6  :  AUDF0  =  _SoundCounter

	LDA _SoundEffect
	CMP #SND_DIE
     BNE .skipL0158
.condpart50
	LDA #8
	STA AUDV0
	LDA #6
	STA AUDC0
	LDA _SoundCounter
	STA AUDF0
.skipL0158
.L0159 ;  if _SoundEffect  =  SND_LEVELUP then AUDV0  =  8  :  AUDC0  =  14  :  AUDF0  =  31  -  _SoundCounter

	LDA _SoundEffect
	CMP #SND_LEVELUP
     BNE .skipL0159
.condpart51
	LDA #8
	STA AUDV0
	LDA #14
	STA AUDC0
	LDA #31
	SEC
	SBC _SoundCounter
	STA AUDF0
.skipL0159
.L0160 ;  _SoundCounter  =  _SoundCounter  +  1

	INC _SoundCounter
.L0161 ;  if _SoundCounter  =  32 then _SoundCounter  =  0  :  _SoundEffect  =  0

	LDA _SoundCounter
	CMP #32
     BNE .skipL0161
.condpart52
	LDA #0
	STA _SoundCounter
	STA _SoundEffect
.skipL0161
.L0162 ;  return

	RTS
 ifconst pfres
 if (<*) > (254-pfres*pfwidth)
	align 256
	endif
 if (<*) < (136-pfres*pfwidth)
	repeat ((136-pfres*pfwidth)-(<*))
	.byte 0
	repend
	endif
 else
 if (<*) > 206
	align 256
	endif
 if (<*) < 88
	repeat (88-(<*))
	.byte 0
	repend
	endif
 endif
pfcolorlabel13
 .byte  $8E,0,0,0
 .byte  $8E,0,0,0
 .byte  $8E,0,0,0
 .byte  $C4,0,0,0
 .byte  $F4,0,0,0
 .byte  $F2,0,0,0
 .byte  $F0,0,0,0
 .byte  $AA,0,0,0
 .byte  $A8,0,0,0
 .byte  $A6,0,0,0
 .byte  $A4,0,0,0
 if (<*) > (<(*+3))
	repeat ($100-<*)
	.byte 0
	repend
	endif
playerL089_1

	.byte  %00000000
	.byte  %10011001
	.byte  %01100110
 if (<*) > (<(*+3))
	repeat ($100-<*)
	.byte 0
	repend
	endif
playerL091_1

	.byte  %01000010
	.byte  %00100100
	.byte  %00011000
 if (<*) > (<(*+4))
	repeat ($100-<*)
	.byte 0
	repend
	endif
playerL097_1

	.byte  %10011110
	.byte  %01111111
	.byte  %01111101
	.byte  %10011110
 if (<*) > (<(*+4))
	repeat ($100-<*)
	.byte 0
	repend
	endif
playerL099_1

	.byte  %01011110
	.byte  %01111111
	.byte  %01111101
	.byte  %01011110
 if (<*) > (<(*+5))
	repeat ($100-<*)
	.byte 0
	repend
	endif
playerL0104_1

	.byte  %10000001
	.byte  %01111110
	.byte  %11111010
	.byte  %10001100
	.byte  %01000000
 if (<*) > (<(*+5))
	repeat ($100-<*)
	.byte 0
	repend
	endif
playerL0106_1

	.byte  %00100100
	.byte  %01111110
	.byte  %01111010
	.byte  %01001100
	.byte  %00100000
       echo "    ",[(scoretable - *)]d , "bytes of ROM space left")
 
 
 
; feel free to modify the score graphics - just keep each digit 8 high
; and keep the conditional compilation stuff intact
 ifconst ROM2k
   ORG $F7AC
 else
   ifconst bankswitch
     if bankswitch == 8
       ORG $2F94-bscode_length
       RORG $FF94-bscode_length
     endif
     if bankswitch == 16
       ORG $4F94-bscode_length
       RORG $FF94-bscode_length
     endif
     if bankswitch == 32
       ORG $8F94-bscode_length
       RORG $FF94-bscode_length
     endif
   else
     ORG $FF9C
   endif
 endif


scoretable
       .byte %00111100
       .byte %01100110
       .byte %01100110
       .byte %01100110
       .byte %01100110
       .byte %01100110
       .byte %01100110
       .byte %00111100

       .byte %01111110
       .byte %00011000
       .byte %00011000
       .byte %00011000
       .byte %00011000
       .byte %00111000
       .byte %00011000
       .byte %00001000

       .byte %01111110
       .byte %01100000
       .byte %01100000
       .byte %00111100
       .byte %00000110
       .byte %00000110
       .byte %01000110
       .byte %00111100

       .byte %00111100
       .byte %01000110
       .byte %00000110
       .byte %00000110
       .byte %00011100
       .byte %00000110
       .byte %01000110
       .byte %00111100

       .byte %00001100
       .byte %00001100
       .byte %01111110
       .byte %01001100
       .byte %01001100
       .byte %00101100
       .byte %00011100
       .byte %00001100

       .byte %00111100
       .byte %01000110
       .byte %00000110
       .byte %00000110
       .byte %00111100
       .byte %01100000
       .byte %01100000
       .byte %01111110

       .byte %00111100
       .byte %01100110
       .byte %01100110
       .byte %01100110
       .byte %01111100
       .byte %01100000
       .byte %01100010
       .byte %00111100

       .byte %00110000
       .byte %00110000
       .byte %00110000
       .byte %00011000
       .byte %00001100
       .byte %00000110
       .byte %01000010
       .byte %00111110

       .byte %00111100
       .byte %01100110
       .byte %01100110
       .byte %01100110
       .byte %00111100
       .byte %01100110
       .byte %01100110
       .byte %00111100

       .byte %00111100
       .byte %01000110
       .byte %00000110
       .byte %00111110
       .byte %01100110
       .byte %01100110
       .byte %01100110
       .byte %00111100 


 ifconst ROM2k
   ORG $F7FC
 else
   ifconst bankswitch
     if bankswitch == 8
       ORG $2FF4-bscode_length
       RORG $FFF4-bscode_length
     endif
     if bankswitch == 16
       ORG $4FF4-bscode_length
       RORG $FFF4-bscode_length
     endif
     if bankswitch == 32
       ORG $8FF4-bscode_length
       RORG $FFF4-bscode_length
     endif
   else
     ORG $FFFC
   endif
 endif
 ifconst bankswitch
   if bankswitch == 8
     ORG $2FFC
     RORG $FFFC
   endif
   if bankswitch == 16
     ORG $4FFC
     RORG $FFFC
   endif
   if bankswitch == 32
     ORG $8FFC
     RORG $FFFC
   endif
 else
   ifconst ROM2k
     ORG $F7FC
   else
     ORG $FFFC
   endif
 endif
 .word start
 .word start
